unit NetUtils;

{$DEFINE DEBUG}
{$UNDEF DEBUG}

{$IFNDEF DEBUG}
{$O+,D-,Q-,R-}
{$ENDIF DEBUG}

{ $Revision: $ }
{  $Archive: $ }
{ $Workfile: $ }
{   $Author: $ }
{     $Date: $ }
{  $Modtime: $ }
{  $History: $ }
{ $NoKeywords: $ }

interface

	function NetbiosECAddress : String;
	function WinSockECAddress : String;

implementation

uses
	Windows,
	NetApi32,
	Winsock,
	Dialogs,
	SysUtils;
	
function NetbiosECAddress : String;
var
	ncb						: TNCB;
	rc						: UCHAR;
	ncbCallname		: TNCBName;
	ncbName				: TNCBName;
	lanaEnum			: TLANA_ENUM;
//	adapterStatus	: TADAPTER_STATUS;
	ncbBuffer			: PUCHAR;
	bufferSize		: Integer;
begin
	Result	:= '';
	FillChar(ncbCallname, SizeOf(TNCBName), ' ');
	FillChar(ncbName, SizeOf(TNCBName), ' ');
	FillChar(lanaEnum, SizeOf(TLANA_ENUM), 0);

	with ncb do begin
		ncb_command		:= NCBENUM;
		ncb_retcode		:= 0;
		ncb_lsn				:= 0;
		ncb_num				:= 1;
		ncb_buffer		:= @lanaEnum;
		ncb_length		:= SizeOf(TLANA_ENUM);
		FillChar(ncb_callname, SizeOf(TNCBName), ' ');
		FillChar(ncb_name, SizeOf(TNCBName), ' ');
		ncb_rto				:= 0;
		ncb_sto				:= 0;
		ncb_post			:= nil;
		ncb_lana_num	:= 0;
		ncb_cmd_cplt	:= 0;
		FillChar(ncb_reserve, 10, 0);
		ncb_event			:= 0;
	end;
	rc	:= Netbios(@ncb);

	if rc > 0 then begin
		ShowNetApiError(rc);
		end
	else begin
//		ShowMessage('Number of LAN adapters : ' + IntToStr(lanaEnum.length));
	end;

	if lanaEnum.length > 0 then begin
		FillChar(ncb, SizeOf(TNCB), 0);
		ncb.ncb_command	:= NCBRESET;
		rc	:= Netbios(@ncb);

		if rc > 0 then begin
			ShowNetApiError(rc);
			end
		else begin
//			ShowMessage('Reset ok!');
		end;

		// MSDN Query 'NCBASTAT'
		// Getting the MAC Address for an Ethernet Adapter
		// You can use the Netbios function to get the Media Access 
		// Control (MAC) address for an ethernet adapter if your card 
		// is bound to NetBIOS. The following example uses the NCBASTAT 
		// command, providing an asterisk ( * ) as the name in the ncb_callname 
		// member of the NCB structure.
		//
		// Note The following code does not work reliably on Windows 95.
		// But works fine for me! (Chris Ueberall)

		bufferSize	:= SizeOf(TADAPTER_STATUS) + 30 * SizeOf(TNAME_BUFFER);
		GetMem(ncbBuffer, bufferSize);
		try
			with ncb do begin
				ncb_command		  := NCBASTAT;
				ncb_retcode		  := 0;
				ncb_lsn				  := 0;
				ncb_num				  := 1;
				ncb_buffer		  := ncbBuffer;
				ncb_length		  := bufferSize;
				FillChar(ncb_callname, SizeOf(TNCBName), ' ');
				// callname must be an asterisk here -> otherwise you'll get a timeout error!
				ncb_callname[0]	:= Ord('*');
				FillChar(ncb_name, SizeOf(TNCBName), ' ');
				ncb_rto			   	:= 0;
				ncb_sto			   	:= 0;
				ncb_post			  := nil;
				ncb_lana_num   	:= lanaEnum.lana[0];
				ncb_cmd_cplt	  := 0;
				FillChar(ncb_reserve, 10, 0);
				ncb_event		   	:= 0;
			end;
	
			try
				rc	:= Netbios(@ncb);
			except
				on E:Exception do begin
					ShowMessage(E.Message);
				end;
			end;
	
			if rc > 0 then begin
				ShowNetApiError(rc);
				end
			else begin
				with TADAPTER_STATUS(Pointer(ncb.ncb_buffer)^) do begin
					Result	:= format('%.2x%.2x%.2x%.2x%.2x%.2x',
							[adapter_address[0],
							adapter_address[1],
							adapter_address[2],
							adapter_address[3],
							adapter_address[4],
							adapter_address[5]]);
				end;
//				ShowMessage('The Ethernet Number is: ' + Result);
			end;
		finally
			FreeMem(ncbBuffer);
		end;
	end;
end;

// the next function is based on a code snippet
// from Hans Pickartz, some minor changes are mines.
function WinSockECAddress : String;
type
	PSockAddrIpx = ^TSockAddrIpx;
	TSockAddrIpx	= packed record
		sa_family		: smallint;
		sa_netnum		: array [1..4] of byte;
		sa_nodenum	: array [1..6] of byte;
		sa_socket		: Word;
	end;

const
	NSPROTO_IPX		= 1000;
	NSPROTO_SPX		= 1256;
	NSPROTO_SPXII	= 1257;
var
	data		: TWSADATA;
	sock		: TSocket;
	addr		: TSockAddrIpx;
	pAddr		: PSockAddr;
	nameLen	: Integer;
begin
	if WSAStartup($0101, data) <> 0 then begin
		ShowMessage('WinSocketError [' + IntToStr(WSAGetLastError) + ']');
		Exit;
	end;

	try
		sock := socket(AF_IPX, SOCK_SEQPACKET, NSPROTO_SPX);
	
		if sock = INVALID_SOCKET then begin
			ShowMessage('WinSocketError [' + IntToStr(WSAGetLastError) + ']');
			Exit;
		end;
	
		try
			FillChar(addr, SizeOf(addr), 0);
			addr.sa_family	:= AF_IPX;
			pAddr						:= @addr;
		
			if Bind(sock, pAddr^, SizeOf(addr)) = SOCKET_ERROR then begin
				ShowMessage('WinSocketError [' + IntToStr(WSAGetLastError) + ']');
				Exit;
			end;
		
			nameLen	:= SizeOf(addr);
		
			if GetSockName(sock, pAddr^, nameLen) = SOCKET_ERROR then begin
				ShowMessage('WinSocketError [' + IntToStr(WSAGetLastError) + ']');
				Exit;
			end;

			Result	:= format('%.2x%.2x%.2x%.2x%.2x%.2x',
					[	addr.sa_nodenum[1],
						addr.sa_nodenum[2],
						addr.sa_nodenum[3],
						addr.sa_nodenum[4],
						addr.sa_nodenum[5],
						addr.sa_nodenum[6]
					]);
		finally		 
			CloseSocket(sock);
		end;
	finally		 
		WSACleanup;
	end;
end;

end.
